#ifndef __gf_included_coredump_h
#define __gf_included_coredump_h

struct _corefile_info_t {
	char filename[128];       /* name of the file to create */
	int max_core_size;        /* maximum amount of memory to dump, in K */
};

extern struct _corefile_info_t _corefile_info;

/* coredump_hooksignal:
 *  Hooks the specified signal.  If `chain' is nonzero, when this signal
 *  occurs the handler will chain to the old one when it has finished
 *  dumping core.  Returns zero on success.
 */
int coredump_hooksignal (int sig, int chain);

/* coredump_unhooksignal:
 *  Unhooks the specified signal, restoring the old handler.  Only call 
 *  this if you're sure nothing else has tried to hook the signal since
 *  the coredump handler was installed.  Returns zero on success.
 */
int coredump_unhooksignal (int sig);

/* coredump_hooksignals:
 *  This hooks various useful signals, by calling `coredump_hooksignal'.
 *  `chain' operates in the same way as above.  Returns zero iff all
 *  signals were successfully hooked.
 */
int coredump_hooksignals (int chain);

/* coredump_unhooksignals:
 *  Unhooks the signals hooked by coredump_hooksignales.  Same caveats
 *  as for `coredump_unhooksignal'.  Returns zero iff all signals were
 *  successfully unhooked.
 */
int coredump_unhooksignals();

#endif
