#ifndef __UNITS__
#define __UNITS__

#include "allegro.h"
#include "bapple2.h"

// UNIT RELATED STUFF

#define MAX_UNITS               	1000

#define ORDER_GUARD					0
#define ORDER_RANDOM				1
#define ORDER_GOTO					2
#define ORDER_SEEK_PLAYER			3
#define ORDER_WAIT					4
#define ORDER_GOTO_CLOSEST_MBASE	5

#define NUM_UNITS					4

#define UNIT_NONEXISTENT        	-1
#define UNIT_QUAD               	0
#define UNIT_BOAT					1
#define UNIT_TANK					2
#define UNIT_GUNBOAT				3

// Different types of things in the world, for use with unit_at
#define THING_UNIT			0
#define THING_PROJECTILE	1
#define THING_PLAYER		2

typedef struct unit_t {
	long id;
    long last_shot_time;
    unsigned short shot_rate;
    signed char owner;
    fixed speed;
    fixed maxspeed;
    signed char type;
    int x;
    int y;
    signed int xoff;
    signed int yoff;
    int health;
	int maxhealth;
	int fuel;
    int direction;
    int targetdir;
	char old_orders;
    char orders;
	signed char carrier;	// The player ID of who is carrying this unit
	long wait_start_time;	// Used for waiting for other units to move it!
	struct unit_t *target;			// Targeted unit

// The following is for the path-to-destination:
// (Do not worry, they are only pointers...)

	struct NODE *OPEN;
	struct NODE *CLOSED;
	struct NODE *path;
	signed short dx, dy;	// Destination x and y coordinates

	struct unit_t *next;			// Next unit in linked list

} unit_t;

// Class declarations

/*class unit
{
	public:

    long last_shot_time;
    unsigned short shot_rate;
    signed char owner;
    fixed speed;
    fixed maxspeed;
    signed char type;
    int x;
    int y;
    signed int xoff;
    signed int yoff;
    int health;
	int maxhealth;
	int fuel;
    int direction;
    int targetdir;
	char old_orders;
    char orders;
	long wait_start_time;	// Used for waiting for other units to move it!
	unit *target;			// Targeted unit

// The following is for the path-to-destination:
// (Do not worry, they are only pointers...)

	struct NODE *OPEN;
	struct NODE *CLOSED;
	struct NODE *path;

	unit *next;

	unit(void);  			// Base constructor (automatically virtual)
	virtual ~unit(void); 	// Base destructor

	// Universal unit functions
	void destroy_all_units(void);
	void free_path_nodes(void);
	void issue_order(char neworders);
	void process_orders(void);

	// Unit think function - performs actions for whatever state unit is in
	virtual void think(void);

	virtual void order_guard(void);
	virtual void order_random(void);
	virtual void order_seek_player(void);
	virtual void order_wait(void);
	virtual void order_goto(void);
	virtual void order_goto_closest_mbase(void);
};

class quad : public unit
{
	public:

	quad(void);
};

class boat : public unit
{
	public:

	boat(void);
};

class tank : public unit
{
	public:

	tank(void);
};

class gunboat : public unit
{
	public:

	gunboat(void);
};

*/

#endif
